note
	description: "expanded_class application root class"
	date: "$Date$"
	revision: "$Revision$"

class
	TEST_EXPANDED_CLASS

inherit
	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- Run application.
		do
			add_boolean_case (agent test_expanded_equal)
			add_boolean_case (agent test_expanded)
			add_boolean_case (agent test_expanded_copying)
			add_boolean_case (agent test_expanded_deep_twin)
			show_browser
			run_espec
		end

feature -- Test queries
	test_expanded_equal: BOOLEAN
		local
			eb1, eb2: B1
			eb3, eb4: B2
		do
			-- put a breakpoint here and step into: you'll {ANY}.is_equal
			Result := eb1 /= eb2
			check Result end

			-- put a breakpoint here and step into: you'll {B2}.is_equal
			Result := eb3 = eb4
			check Result end

			-- put a breakpoint and step into: you get an immediate false because
			-- objects of different types are being compared.
			Result := eb1 /= eb3
			check Result end
		end

	test_expanded: BOOLEAN
		local
			eb1, eb2: B1
			eb3, eb4: B2
		do
			Result := eb1.i = 0 and eb2.i = 0 and eb1.s /= eb2.s and eb1.s ~ eb2.s
			check Result end

			Result := eb1 /= eb2 -- eb1.i = eb2.i and eb1.s = eb2.s
			check Result end

			Result := eb3.i = 0 and eb4.i = 0 and eb1.s /= eb2.s and eb1.s ~ eb2.s
			check Result end

			Result := eb3 = eb4 -- eb1.i = eb2.i and eb1.s ~ eb2.s
			check Result end

			eb1.change_s (eb2.s)
			Result := eb1 = eb2 -- eb1.i = eb2.i and eb1.s = eb2.s
			check Result end

			eb3.change_s (eb4.s)
			Result := eb3 = eb4
		end

	test_expanded_copying: BOOLEAN
		local
			eb1, eb2: B1
		do
			Result := eb1.i = 0 and eb2.i = 0 and eb1.s /= eb2.s and eb1.s ~ eb2.s
			check Result end

			Result := eb1 /= eb2 -- eb1.i = eb2.i and eb1.s = eb2.s
			check Result end

			eb1.change_s ("alan")
			eb2 := eb1

			-- copying from one expanded object to another can still cause sharing

			Result := eb1.i = 0 and eb2.i = 0 and eb1.s = eb2.s and eb1.s ~ eb2.s
			check Result end

			Result := eb1 = eb2 -- eb1.i = eb2.i and eb1.s = eb2.s
			check Result end
		end

	test_expanded_deep_twin: BOOLEAN
		local
			eb1, eb2: B1
		do
			Result := eb1.i = 0 and eb2.i = 0 and eb1.s /= eb2.s and eb1.s ~ eb2.s
			check Result end

			Result := eb1 /= eb2 -- eb1.i = eb2.i and eb1.s = eb2.s
			check Result end

			eb1.change_s ("alan")
			eb2 := eb1.deep_twin

			-- copying from one expanded object to another can still cause sharing

			Result := eb1.i = 0 and eb2.i = 0 and eb1.s /= eb2.s and eb1.s ~ eb2.s
			check Result end

			Result := eb1 /= eb2 -- eb1.i = eb2.i and eb1.s = eb2.s
			check Result end
		end
end
